#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_NoviceGrowthCFG.h"
std::auto_ptr<M_NoviceGrowthCFG> M_NoviceGrowthCFG::msSingleton(nullptr);

int M_NoviceGrowthCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_NoviceGrowthCFGData* M_NoviceGrowthCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_NoviceGrowthCFGData>& M_NoviceGrowthCFG::GetMapData()
{
	return mMapData;
}

void M_NoviceGrowthCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_NoviceGrowthCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_NoviceGrowthCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mGroup = element->IntAttribute("Group");
		data.mName = element->Attribute("Name");
		data.mCompleteType = element->IntAttribute("CompleteType");
		{
			const char* CompleteParam = element->Attribute("CompleteParam");
			std::vector<std::string> vecCompleteParam;
			boost::split(vecCompleteParam, CompleteParam, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecCompleteParam.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecCompleteParam[i].c_str(), &temp))
				{
					data.mCompleteParam.push_back(temp);
				}
			}
		}
		data.mCompleteCount = element->IntAttribute("CompleteCount");
		{
			const char* ShowItem = element->Attribute("ShowItem");
			std::vector<std::string> vecShowItem;
			boost::split(vecShowItem, ShowItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecShowItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecShowItem[i].c_str(), &temp))
				{
					data.mShowItem.push_back(temp);
				}
			}
		}
		{
			const char* ShowNumber = element->Attribute("ShowNumber");
			std::vector<std::string> vecShowNumber;
			boost::split(vecShowNumber, ShowNumber, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecShowNumber.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecShowNumber[i].c_str(), &temp))
				{
					data.mShowNumber.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemIDs = element->Attribute("AwardItemIDs");
			std::vector<std::string> vecAwardItemIDs;
			boost::split(vecAwardItemIDs, AwardItemIDs, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemIDs.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemIDs[i].c_str(), &temp))
				{
					data.mAwardItemIDs.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemCounts = element->Attribute("AwardItemCounts");
			std::vector<std::string> vecAwardItemCounts;
			boost::split(vecAwardItemCounts, AwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemCounts[i].c_str(), &temp))
				{
					data.mAwardItemCounts.push_back(temp);
				}
			}
		}
		data.mGoType = element->IntAttribute("GoType");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_NoviceGrowthCFG Loaded. Load Data:%u", mMapData.size());
}

void M_NoviceGrowthCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_NoviceGrowthCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_NoviceGrowthCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_NoviceGrowthCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Group", data.mGroup);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readInt(L, "CompleteType", data.mCompleteType);
		LuaCfgHelper::readVectorInt(L, "CompleteParam", data.mCompleteParam);
		LuaCfgHelper::readInt(L, "CompleteCount", data.mCompleteCount);
		LuaCfgHelper::readVectorInt(L, "ShowItem", data.mShowItem);
		LuaCfgHelper::readVectorInt(L, "ShowNumber", data.mShowNumber);
		LuaCfgHelper::readVectorInt(L, "AwardItemIDs", data.mAwardItemIDs);
		LuaCfgHelper::readVectorInt(L, "AwardItemCounts", data.mAwardItemCounts);
		LuaCfgHelper::readInt(L, "GoType", data.mGoType);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_NoviceGrowthCFG Loaded. Load Data:%u", mMapData.size());
}

void M_NoviceGrowthCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_NoviceGrowthCFG* M_NoviceGrowthCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_NoviceGrowthCFG());
	}
	return msSingleton.get();
}

void M_NoviceGrowthCFG::Release()
{
	msSingleton.reset(nullptr);
}
